function samples = pla_sample(tracks,param,samplelengthsnm);

%create output thingy
samples.p         = cell ([param.global.nrandomdraws,length(samplelengthsnm)]);
samples.r         = cell ([param.global.nrandomdraws,length(samplelengthsnm)]);
samples.nelements = zeros([param.global.nrandomdraws,length(samplelengthsnm)]);

backmap = sparse(samplelengthsnm,...
    ones([1,length(samplelengthsnm)]),...
    [1:length(samplelengthsnm)]);

for jj = 1 : size(tracks,2)
  %  fprintf('\r SAMPLE %3d / %3d',jj,size(tracks,2));
    if isfield(tracks{jj},'x') & ~isempty(tracks{jj}.x)
        p    = unwrap(tracks{jj}.phi,[],2);
        for ll = 1 : param.global.nrandomdraws
            [ ind , siz ] = sampling( length(tracks{jj}.phi),samplelengthsnm );
            for kk=1:size(siz,2)
            %%  	fprintf('\r sampling %3d %3d %3d',jj,ll,kk);
            if 0
	        	cor = 3

                dx_  = tracks{jj}.x( ind(kk) ) - tracks{jj}.x( ind(kk) + siz(kk)+cor);
                dy_  = tracks{jj}.y( ind(kk) ) - tracks{jj}.y( ind(kk) + siz(kk)+cor);
                dr_  = sqrt( dx_^2 + dy_^2 );
                dp_  = p( ind(kk) ) - p( ind(kk) + siz(kk) +cor);
                kkk  = backmap( siz(kk) );
                samples.r{ll,kkk}         = [samples.r{ll,kkk} ; dr_];
                samples.p{ll,kkk}         = [samples.p{ll,kkk} ; dp_];
                samples.nelements(ll,kkk) = samples.nelements(ll,kkk) + 1;
                %	fprintf('%5.2f %5.2f \n',[sqrt(dx_.^2+dy_.^2),siz(kk)]);
                else
                    % 11 sep 2008 this is the correct way, no +1 needed on
                    % siz(kk); only increases the effective distance and
                    % thereby the angles.
                dx_  = tracks{jj}.x( ind(kk) ) - tracks{jj}.x( ind(kk) + siz(kk));
                dy_  = tracks{jj}.y( ind(kk) ) - tracks{jj}.y( ind(kk) + siz(kk));
                dr_  = sqrt( dx_^2 + dy_^2 );
                dp_  = p( ind(kk) ) - p( ind(kk) + siz(kk) );
                kkk  = backmap( siz(kk) );
                samples.r{ll,kkk}         = [samples.r{ll,kkk} ; dr_];
                samples.p{ll,kkk}         = [samples.p{ll,kkk} ; dp_];
                samples.nelements(ll,kkk) = samples.nelements(ll,kkk)+1;
           end
                
                
            end
        end
    end
end



for kk = 1 : param.global.nrandomdraws
    for ii = 1 : length(samplelengthsnm )
        samples.meanthetasquared (kk,ii) = mean(    samples.p{kk,ii}.^2 );
        samples.meanthetaquad    (kk,ii) = mean(    samples.p{kk,ii}.^4 );
        samples.meancos          (kk,ii) = mean(cos(samples.p{kk,ii}   ));
        samples.meanrsquared     (kk,ii) = mean(    samples.r{kk,ii}.^2 );
        samples.meanrquad        (kk,ii) = mean(    samples.r{kk,ii}.^4 );
        samples.nelements        (kk,ii) = length(  samples.p{kk,ii}    );
        samples.meanr            (kk,ii) = mean(    samples.r{kk,ii}    );
    end
end

%cut track into pieces of random "length"
function [ind,siz]=sampling(sz,samplevalues)
rest = sz-5;%should be -1 only -2 for the dirty 1nm fix
position = 1;
ii = 1;

while rest >= samplevalues(1)
    ind(ii) = position;
    rnd = ceil(sum(samplevalues<=rest)*rand(1));
    if(rnd == 0)
        rnd = 1;
    end
    siz(ii) = samplevalues(rnd);
    rest = rest-siz(ii);
    position = position+siz(ii);
    ii = ii+1;
end

if ~exist('ind')
    ind=[];
    siz=[];
end




