function im = pla_skeleton(param,im)
%
% create mask and labels
%
% The segementation and skeletonisation can be troublesome, this is made to
% run the examples nothing more, i.e. adjust to your needs.
%

[dummy,fn,dummy]=fileparts(param.condition(im.condition).files{im.image});
fnskel = [param.dir.output , filesep ,...
    param.condition(im.condition).name{1} '/',...
    fn '_skel.ics' ];
fnced = [param.dir.output , filesep ,...
    param.condition(im.condition).name{1} '/',...
    fn '_ced.ics' ];

fnflat = [param.dir.output , filesep ,...
    param.condition(im.condition).name{1} '/',...
    fn '_flat.ics' ];


if exist(fnskel,'file') & exist(fnflat,'file')
    fprintf('     older skeleton file found: %s\n',fnskel);
    im.skel = readim(fnskel);
    im.flat = readim(fnflat);
else
    fprintf('     creating skeleton and writing to: %s\n',fnskel);
    
    GAUSSIGMA=20;
    
    
    if param.condition(im.condition).param{im.image}.backgroundisblack == true
        ims = im.im;
    else
        ims = -im.im;
    end
    
    if ~exist(fnced,'file') | ~exist(fnflat,'file')
        im.flat=ims-gaussf(ims,GAUSSIGMA);
        im.flat=im.flat-min(im.flat);
        im.flat=im.flat/max(im.flat);
        im.ced = ced(im.flat,1.0,3.0,20,'const','first','yes');
        writeim(im.ced,fnced,'ICSv2');
        writeim(im.flat,fnflat,'ICSv2');
    else
        im.ced  = readim(fnced);
        im.flat = readim(fnflat);
    end
    
    %IM.CED
    %find dna by first removing left hand side of histogram, i.e. left from
    %median. then determine the foreground by an isodata threshold
    bg_ced             = median(im.ced);
    mask_median_im_ced = im.ced > bg_ced;
    [dum,fg_ced]       = threshold(im.ced(mask_median_im_ced));
    cedbin             = im.ced > fg_ced;
    
    %IM.FLAT
    %find dna in flattend images, i.e. only use ced data to simplify
    %threshold
    
    %    diphist(im.flat(cedbin),'all')
    bg_dna       = median(im.flat(cedbin));
    mask_mean_im = im.flat > bg_dna;
    %    diphist(im.flat(mask_mean_im),'all')
    [dum,fg_dna] = threshold(im.flat(mask_mean_im));
    im.bin       = im.flat > fg_dna;
    
    % repect all pixels in im.bin and skeletonize with this constraint
    im.anchorskel = dip_binaryanchorskeleton2d(cedbin,im.bin,10000,0,0);
    
    %MAGIC,
    MIN_SZ=30;
    SZ_BOUNDARY=5;
    tmp1 = bskeleton(cedbin,0,'1neighbor');
    tmp2 = bskeleton(cedbin,0,'looseendsaway');
    tmp3 = bpropagation(getbranchpixel(tmp1),tmp1,Inf,2,0);
    im.skel=label(~tmp3&tmp1,2,MIN_SZ)~=0;
    im.anchor      = (im.skel&im.bin);
    im.skel = dip_binaryanchorskeleton2d(cedbin|im.bin,im.anchor,10000,1,0);
   
    im.skel = dip_binaryanchorskeleton2d(im.skel,getendpixel(im.skel),10000,1,0);
    im.skel = label(brmedgeobjs(im.skel|bdilation(newim(ims,'bin'),2*SZ_BOUNDARY,-1,1),2),2,MIN_SZ)~=0;
    im.skel = im.skel&~bpropagation(getbranchpixel(im.skel),im.skel,Inf,2,0);%evt branches
    im.skel = bpropagation(getsinglepixel(bskeleton(im.skel,0,'looseendsaway')),im.skel,Inf,2,0);%evt loops
    im.skel = label(im.skel);
   
    writeim(im.skel,fnskel,'ICSv2');
end
im.labs = setdiff(unique(double(im.skel)),0);

